#import "DualQuaternion.h"

@interface ACTION : NSObject {
	
    NSString       *actionName;
    GLushort        actionNodeID;
    GLushort        actionParentNodeID;
    
    DualQuaternion *actionMsBindTransform;              // Model-space transform of Action mono-bone from origin to bind position
    DualQuaternion *actionMsInverseBindTransform;       // Model-space transform of Action mono-bone from bind position back to origin
    DualQuaternion *actionMsAnimatedPoseTransform;      // Model-space transform of Action mono-bone in animated pose position for VShader
    
    NSArray        *actionAnimations;                   // Model-space array of animation keyframe transforms, in the style of Armature bones
    ushort          actionAnimationLength;              // Length of Action's animation, in frames, whether or not there are any keyframes within
}

-(id) init  :(GLushort)new_NodeID  :(GLushort)new_ParentIndex  :(NSString*)new_Name;

-(NSString*)        getName;
-(GLushort)         getNodeID;
-(GLushort)         getParentIndex;
-(DualQuaternion*)  getMsBindTransform;
-(DualQuaternion*)  getMsInverseBindTransform;
-(DualQuaternion*)  getMsAnimatedPoseTransform;
-(NSArray*)         getAnimations;
-(ushort)           getAnimationLength;

-(void) setMsBindTransform          :(DualQuaternion*)new_MsBindTransform;
-(void) setMsInverseBindTransform   :(DualQuaternion*)new_MsInverseBindTransform;
-(void) setMsAnimatedPoseTransform  :(DualQuaternion*)new_MsAnimatedPoseTransform;
-(void) setAnimations               :(NSArray*)new_SynthesizedAnimations;
-(void) setAnimationLength          :(ushort)new_AnimationLength;

@end
