#import "Constants.h"
#import "BONE.h"
#import "ACTION.h"
#import "Matrix4f.h"
#import "Animation.h"
#import "BoneKeyFrame.h"

@interface Animator : NSObject {
    
    Animation       *animations[nAnimationTypes];               // Array of Animation objects, ordered by Armature, Action and BVH animation types
                                                                // each element a bone-based array of BoneKeyFrame objects, ordered by time stamps
    NSMutableArray  *animationTimeMarkers;
    CFTimeInterval   lastFrameTime;
    NSArray         *armatureList;
    NSArray         *actionList;
    NSArray         *bvhList;
    double           delta;
}

-(id)         init  :(NSArray*)in_ArmatureList  :(NSArray*)in_ActionList  :(NSMutableArray*)in_BVHList;

-(void)       uploadAnimation  :(Animation*)new_Animation  :(enum AnimationTypes)in_Type;
-(void)       updateAnimation;

-(Animation*) getAnimation  :(enum AnimationTypes)in_Type;

@end
