#import "BONE.h"

@implementation BONE

-(id) init  :(GLushort)new_Index  :(NSString*)new_BoneName  :(GLushort)new_ParentIndex {
	
    if ((self = [super init])) {
		
        boneIndex                    = new_Index;
        boneBoneName                 = new_BoneName;
        boneParentIndex              = new_ParentIndex;
        boneChildIndices             = nil;
        boneAnimations               = nil;
        boneAnimationLength          = 0;
        boneLsBindTransform          = [DualQuaternion new];    // 'Ls' = Local-space
        boneMsInverseBindTransform   = [DualQuaternion new];    // 'Ms' = Model-space
        boneLsAnimatedPoseTransform  = [DualQuaternion new];
        boneMsAnimatedPoseTransform  = [DualQuaternion new];
        boneLocation                 = nil;
        boneRotation                 = nil;
        boneScale                    = [[Vector3f alloc] init  :1.0  :1.0  :1.0];
    }
    
    return self;
}
    
-(GLushort)         getIndex                   { return boneIndex; }
-(NSString*)        getBoneName                { return boneBoneName; }
-(GLushort)         getParentIndex             { return boneParentIndex; }
-(NSMutableArray*)  getChildIndices            { return boneChildIndices; }
-(NSMutableArray*)  getAnimations              { return boneAnimations; }
-(GLushort)         getAnimationLength         { return boneAnimationLength; }
-(DualQuaternion*)  getLsBindTransform         { return boneLsBindTransform; }
-(DualQuaternion*)  getMsInverseBindTransform  { return boneMsInverseBindTransform; }
-(DualQuaternion*)  getLsAnimatedPoseTransform { return boneLsAnimatedPoseTransform; }
-(DualQuaternion*)  getMsAnimatedPoseTransform { return boneMsAnimatedPoseTransform; }
-(Vector3f*)        getLocation                { return boneLocation; }
-(Vector4f*)        getRotation                { return boneRotation; }
-(Vector3f*)        getScale                   { return boneScale; }

-(void) setChildIndices             :(NSMutableArray*)new_ChildIndices               { boneChildIndices            = new_ChildIndices; }
-(void) setAnimations               :(NSMutableArray*)new_Animations                 { boneAnimations              = new_Animations; }
-(void) setAnimationLength          :(GLushort)new_AnimationLength                   { boneAnimationLength         = new_AnimationLength; }
-(void) setLsBindTransform          :(DualQuaternion*)new_LocalBindTransform         { boneLsBindTransform         = new_LocalBindTransform; }
-(void) setMsInverseBindTransform   :(DualQuaternion*)new_ModelInverseBindTransform  { boneMsInverseBindTransform  = new_ModelInverseBindTransform; }
-(void) setLsAnimatedPoseTransform  :(DualQuaternion*)new_LocalAnimatedPoseTransform { boneLsAnimatedPoseTransform = new_LocalAnimatedPoseTransform; }
-(void) setMsAnimatedPoseTransform  :(DualQuaternion*)new_ModelAnimatedPoseTransform { boneMsAnimatedPoseTransform = new_ModelAnimatedPoseTransform; }
-(void) setLocation                 :(Vector3f*)new_Location        { boneLocation = new_Location; }
-(void) setRotation                 :(Vector4f*)new_Rotation        { boneRotation = new_Rotation; }
-(void) setScale                    :(Vector3f*)new_Scale           { boneScale    = new_Scale; }

@end
