@implementation NSMutableDictionary (Extra)

//  From https://stackoverflow.com/a/23239310

//  Adds a Category to NSMutableDictionary to return the contents as an immutable NSArray, sorted by key

-(NSArray*) sortedKeys              { return [[self allKeys] sortedArrayUsingSelector  :@selector(compare:)]; }

-(NSArray*) allValuesSortedByKey    { return [self objectsForKeys  :self.sortedKeys notFoundMarker:[NSNull null]]; }

-(id) firstKey                      { return [self.sortedKeys firstObject]; }

-(id) firstValue                    { return [self valueForKey: [self firstKey]]; }

@end
