#import "Vector3f.h"

@interface Matrix4f : NSObject {

    @public float m00, m01, m02, m03, m10, m11, m12, m13, m20, m21, m22, m23, m30, m31, m32, m33;
}

-(id)        init;
-(Matrix4f*) cmMatrixFromBytes    :(float*)sourceBytes;         // Column-Major matrix from raw byte array
-(Matrix4f*) rmMatrixFromBytes    :(float*)sourceBytes;         // Row-Major       "     "   "   "     "
-(Matrix4f*) cmMatrixFromNSArray  :(NSArray*)sourceArray;       // Column-Major matrix from NSArray
-(Matrix4f*) rmMatrixFromNSArray  :(NSArray*)sourceArray;       // Row-Major       "     "     "
-(float*)    getPtr;

+(Matrix4f*) multiply   :(Matrix4f*)left   :(Matrix4f*)right;
+(Matrix4f*) scale      :(Vector3f*)vec    :(Matrix4f*)src;
+(Matrix4f*) translate  :(Vector3f*)vec    :(Matrix4f*)src;
+(Matrix4f*) transpose  :(Matrix4f*)src;

@end
