#define GLM_ENABLE_EXPERIMENTAL
#import <glm/gtc/type_ptr.hpp>
#import <glm/gtx/matrix_decompose.hpp>
#import <glm/gtx/string_cast.hpp>
#import <iostream>

#import "Vector3f.h"
#import "Vector4f.h"
#import "Quaternion.h"

@interface Matrix4fDecomposed : NSObject {

    @public Vector4f    *rotation;
    @public Vector3f    *position;
    @public Vector3f    *scale;
    @public Vector3f    *skew;
    @public Vector4f    *perspective;

            glm::quat    dcRotationQuat;    // Decomposed Rotation as glm::quat
            glm::vec4    dcRotationVec4;    // ... "         "      " glm::vec4
            glm::vec3    dcPosition;        // ... "      Position  " glm::vec3
            glm::vec3    dcScale;           // ... "      Scale     " glm::vec3
            glm::vec3    dcSkew;            // Not usually used, but available
            glm::vec4    dcPerspective;     // Not usually used, but available
}

-(Matrix4fDecomposed*) decomposeFromGLM  :(glm::mat4)in_glmMat4  :(bool)logging;

@end
