#import "Matrix4fDecomposed.h"

@implementation Matrix4fDecomposed

using namespace std;

-(Matrix4fDecomposed*) decomposeFromGLM  :(glm::mat4)in_glmMat4  :(bool)logging {

    glm::decompose (in_glmMat4, dcScale, dcRotationQuat, dcPosition, dcSkew, dcPerspective);

    dcRotationVec4 = glm::vec4 (dcRotationQuat.x, dcRotationQuat.y, dcRotationQuat.z, dcRotationQuat.w);

    rotation    = [[Vector4f alloc] initFromGLM  :dcRotationVec4];
    position    = [[Vector3f alloc] initFromGLM  :dcPosition];
    scale       = [[Vector3f alloc] initFromGLM  :dcScale];
    
    skew        = [[Vector3f alloc] initFromGLM  :dcSkew];
    perspective = [[Vector4f alloc] initFromGLM  :dcPerspective];

    if (logging) {
      
      std::cout << "MeshP2->Matrix4fDecomposed\tRotationQuat: " << glm::to_string (dcRotationQuat)
                << "\tPosition: " << glm::to_string (dcPosition) << std::endl;
    }

    return self;
}

@end
