#import <OpenGL/gl3.h>
#import "MeshP2.h"
#import "Math_Routines.h"
#import "File_Routines.h"
#import "P2Scene.h"
#import "VERTEX.h"
#import "TRIANGLE.h"
#import "SURFACE.h"
#import "POLYGONLIST.h"
#import "BONE.h"
#import "ACTION.h"

@interface MeshP2 (OpenGL_Routines)

-(void)	  Convert_to_OpenGL;
-(void)	  AddMaterial               :(GLfloat*)ambient	  :(GLfloat*)diffuse	   :(GLfloat*)specular      :(GLfloat)shininess  :(GLfloat)alpha
                                    :(char*)name          :(char*)textureMap1Name  :(char*)textureMap2Name  :(char*)bumpmapName  :(BOOL)doubleSided;
-(void)	  AddPolygon                :(TRIANGLE*)triangle  :(char*)MaterialName;
-(int)	  FindMaterialIndex         :(char*)name;
-(bool)   CalculateSurfaceNormal    :(SURFACE*)surface;
-(void)	  LinkVerticesToPolygons;
-(void)	  CalculateVertexNormalsAndTangents;
-(void)   SetupVAOVBOandIBO;
-(void)   SetupShaders;
-(void)   ShaderStatus              :(GLuint)Object	     :(GLenum)Parameter;
-(GLuint) CompileShaderType         :(GLenum)type        :(NSString*)file;

@end
