#import "Constants.h"
#import "Math_Routines.h"

@interface P2Action : NSObject {
    
    char            actionName[MAX_NAMESIZE];       // Matches mesh object name
    ushort          actionNodeID;                   // Matches mesh object index
    ushort          actionParentNodeID;
    ushort          actionAnimationLength;          // Length of animation (frames)
    
    Matrix4f       *actionMsBindTransform;
    NSArray        *actionAnimations;
    
    @public struct  {
                    uint32      frame_start, frame_end, nKeys;
                    NSMutableDictionary<NSNumber*, Vector3f*> *keyframes;
                    } actionLocation;
        
    @public struct  {
                    uint32      frame_start, frame_end, nKeys;
                    NSMutableDictionary<NSNumber*, Vector4f*> *keyframes;
                    } actionRotation;
        
    @public struct  {
                    uint32      frame_start, frame_end, nKeys;
                    NSMutableDictionary<NSNumber*, Vector3f*> *keyframes;
                    } actionScale;
}

-(char*)     getName;
-(ushort)    getNodeID;
-(ushort)    getParentNodeID;
-(Matrix4f*) getMsBindTransform;
-(NSArray*)  getAnimations;
-(ushort)    getAnimationLength;

-(void) setName             :(char*)new_Name;
-(void) setNodeID           :(ushort)new_NodeID;
-(void) setParentNodeID     :(ushort)new_ParentNodeID;
-(void) setMsBindTransform  :(Matrix4f*)new_MsBindTransform;
-(void) setAnimationLength  :(ushort)new_AnimationLength;

-(void) synthesizeActionAnimations;

@end
