#import "Constants.h"
#import "Math_Routines.h"

@interface P2ArmatureBone : NSObject {
    
    NSString       *boneName;
    ushort          boneIndex;
    ushort          boneParentIndex;
    ushort          boneAnimationLength;
    
    NSMutableArray *boneChildIndices;
    NSMutableArray *boneAnimations;
    
    Matrix4f       *boneLsBindTransform;
    Vector3f       *boneLocation;
    Vector4f       *boneRotation;
    Vector3f       *boneScale;
}

-(NSString*)        getName;
-(ushort)           getIndex;
-(ushort)           getParentIndex;
-(ushort)           getAnimationLength;
-(NSMutableArray*)  getChildIndices;
-(NSMutableArray*)  getAnimations;
-(Matrix4f*)        getLsBindTransform;
-(Vector3f*)        getLocation;
-(Vector4f*)        getRotation;
-(Vector3f*)        getScale;

-(void) setName             :(NSString*)new_Name;
-(void) setIndex            :(ushort)new_Index;
-(void) setParentIndex      :(ushort)new_ParentIndex;
-(void) setAnimationLength  :(ushort)new_AnimationLength;
-(void) setChildIndices     :(NSMutableArray*)new_ChildIndices;
-(void) setAnimations       :(NSMutableArray*)new_AnimationTransforms;
-(void) setLsBindTransform  :(Matrix4f*)new_LocalBindTransform;
-(void) setLocation         :(Vector3f*)new_Location;
-(void) setRotation         :(Vector4f*)new_Rotation;
-(void) setScale            :(Vector3f*)new_Scale;

@end
