#import	"Constants.h"
#import "P2TextureMap.h"
#import "P2RGBColor.h"

@interface P2Material : NSObject {
    
    char            name[MAX_NAMESIZE];
    float           transparency;
    float           shininess;
        
    BOOL            doublesided;
        
    P2RGBColor      *ambient;
    P2RGBColor      *diffuse;
    P2RGBColor      *specular;
    
    P2TextureMap    *textureMap1;
    P2TextureMap    *textureMap2;
    P2TextureMap    *bumpMap;
}

-(P2RGBColor*) getAmbient;
-(P2RGBColor*) getDiffuse;
-(P2RGBColor*) getSpecular;

-(P2TextureMap*)  getTextureMap1;
-(P2TextureMap*)  getTextureMap2;
-(P2TextureMap*)  getBumpMap;

-(float*)   getTransparency;
-(float*)   getShininess;
-(BOOL*)    getDoubleSided;
-(char*)    getMatName;

-(void)     setMatName	    :(char*)newMatName;
-(void)     setDoubleSided  :(BOOL)newDoublesided;

@end
