#import "P2MaterialFacesList.h"
#import "P2Vertex.h"
#import "P2Face.h"
#import "P2Map.h"
#import "P2VertexFlag.h"
#import "P2ArmatureBone.h"
#import "P2Action.h"

@interface P2MeshObj : NSObject {
    
    char  meshName[MAX_NAMESIZE];       // Mesh object name, null terminated
    float transformMatrix[16];          // Imported Armature scale, translation

    NSMutableArray *vertList;           // Array of P2Vertex objects (vertices)
    NSMutableArray *faceList;			// Array of P2Face objects (face indices)
    NSMutableArray *mapList;            // Array of P2Map objects (texture coordinates)
    NSMutableArray *matList;			// Array of P2Material objects (materials)
    NSMutableArray *vertFlagList;       // Array of P2VertexFlag objects
    NSMutableArray *armatureList;       // Array of P2ArmatureBone objects
    NSMutableArray *actionList;         // Array of P2Action, non-Armature objects
}

-(char*)  getName;
-(id)     getVertList;
-(id)	  getFaceList;
-(id)     getMapList;
-(id)	  getMatList;
-(id)     getVertFlagList;
-(id)     getArmatureList;
-(id)     getActionList;
-(float*) getTransformMatrix;

-(void)   setMeshName             :(char*)new_Name;
-(void)   setTransformMatrix      :(float*)new_TransformMatrix;

-(id)     addVert;
-(id)	  addFace;
-(id)	  addMap;
-(id)     addMatList;
-(id)     addVertFlag;
-(id)     addArmatureBone;
-(id)     addAction;

@end
