#import "P2MeshObj.h"

@implementation P2MeshObj

-(id)    init {
    
    if (self = [super init]) {
        
		meshName[0]      = '\0';
        vertList         = [NSMutableArray new];
        faceList         = [NSMutableArray new];
        mapList          = [NSMutableArray new];
        matList          = [NSMutableArray new];
        vertFlagList     = [NSMutableArray new];
        armatureList     = [NSMutableArray new];
        actionList       = [NSMutableArray new];
    }
    
    return self;
}

-(char*) getName { return meshName; }

-(id)    addVert {
    
    [vertList addObject  :[P2Vertex new]];
    
    return [vertList lastObject];
}

-(id)    addFace {
    
    [faceList addObject  :[P2Face new]];

    return [faceList lastObject];
}

-(id)    addMap {
    
    [mapList addObject  :[P2Map new]];
	
    return [mapList lastObject];
}

-(id)    addMatList {
    
    [matList addObject  :[P2MaterialFacesList new]];

    return [matList lastObject];
}

-(id)    addVertFlag {
    
    [vertFlagList addObject  :[P2VertexFlag new]];
    
    return [vertFlagList lastObject];
}

-(id)    addArmatureBone {
    
    [armatureList addObject  :[P2ArmatureBone new]];
    
    return [armatureList lastObject];
}

-(id)    addAction {
    
    [actionList addObject  :[P2Action new]];
    
    return [actionList lastObject];
}

-(id)     getFaceList	         { return faceList; }
-(id)     getVertList	         { return vertList; }
-(id)     getMapList             { return mapList; }
-(id)     getMatList	         { return matList; }
-(id)     getVertFlagList        { return vertFlagList; }
-(id)     getArmatureList        { return armatureList; }
-(id)     getActionList          { return actionList; }
-(float*) getTransformMatrix     { return transformMatrix; }

-(void)   setMeshName	          :(char*)new_name	  { strcpy (meshName, new_name); }
-(void)   setTransformMatrix      :(float*)new_Matrix { memcpy (transformMatrix, new_Matrix, sizeof(transformMatrix)); }

@end
