#import "POLYGONLIST.h"
#import "SURFACE.h"

@implementation POLYGONLIST

-(id) init {
	
    if ((self = [super init])) {
        
        name[0]             = '\0';
        textureMap1Name[0]  = '\0';
        textureMap2Name[0]  = '\0';
        bumpMapName[0]      = '\0';
            
        textureMap1ID       = 0;
        textureMap2ID       = 0;
        bumpMapID           = 0;
        materialIBO         = 0;
        
        iboSize             = 0;
        iboBuffer           = nil;
            
		SurfaceIndexList	= [NSMutableArray new];
    }
    
    return self;
}
    
-(void) dealloc {
	
    if  (glIsTexture (textureMap1ID))   glDeleteTextures (1, &textureMap1ID);
    if  (glIsTexture (textureMap2ID))   glDeleteTextures (1, &textureMap2ID);
    if  (glIsTexture (bumpMapID))       glDeleteTextures (1, &bumpMapID);
    if  (glIsBuffer  (materialIBO))     glDeleteBuffers  (1, &materialIBO);
    
    if  (iboBuffer != nil) free (iboBuffer);
}

-(id)	getSurfaceIndexList		 { return SurfaceIndexList; }
-(int)	getSurfaceIndexListCount { return (int)[SurfaceIndexList count]; }

-(id)	addSurfaceIndexList {
	
    [SurfaceIndexList addObject  :[SURFACE new]];

    return [SurfaceIndexList lastObject];
}

-(char*)	getName			    { return name; }
-(char*)    getTextureMap1Name  { return textureMap1Name; }
-(char*)    getTextureMap2Name  { return textureMap2Name; }
-(char*)    getBumpMapName      { return bumpMapName; }

-(void)     genTextureMap1ID    { glGenTextures     (1, &textureMap1ID); }
-(void)     genTextureMap2ID    { glGenTextures     (1, &textureMap2ID); }
-(void)     genBumpMapID        { glGenTextures     (1, &bumpMapID); }
-(void)     genMaterialIBO      { glGenBuffers      (1, &materialIBO); }

-(GLuint)   getTextureMap1ID    { return textureMap1ID; }
-(GLuint)   getTextureMap2ID    { return textureMap2ID; }
-(GLuint)   getBumpMapID        { return bumpMapID; }
-(GLuint)   getMaterialIBO      { return materialIBO; }
-(GLuint*)  getIBOBuffer        { return iboBuffer; }
-(GLuint)   getIBOSize          { return iboSize; }

-(GLfloat*)	getAmbient		    { return ambient; }
-(GLfloat*)	getDiffuse		    { return diffuse; }
-(GLfloat*)	getSpecular		    { return specular; }
-(GLfloat)  getShininess        { return shininess; }
-(GLfloat)  getAlpha            { return alpha; }

-(BOOL)		getDoubleSided	    { return doublesided; }

-(void)		setName			    :(char*)new_Name		 { strcpy (name, new_Name); }
-(void)		setTextureMap1Name	:(char*)new_Texture1Name { strcpy (textureMap1Name, new_Texture1Name); }
-(void)     setTextureMap2Name  :(char*)new_Texture2Name { strcpy (textureMap2Name, new_Texture2Name); }
-(void)     setBumpMapName      :(char*)new_BumpMapName  { strcpy (bumpMapName, new_BumpMapName); }

-(void)		setAmbient 		:(GLfloat*)new_Ambient	{ memcpy (&ambient, new_Ambient,  sizeof(ambient)); }
-(void)		setDiffuse 		:(GLfloat*)new_Diffuse	{ memcpy (&diffuse, new_Diffuse,  sizeof(diffuse)); }
-(void)		setSpecular		:(GLfloat*)new_Specular	{ memcpy (&specular, new_Specular, sizeof(specular)); }
-(void)		setShininess    :(GLfloat)new_Shininess { shininess = new_Shininess; }
-(void)		setAlpha        :(GLfloat)new_Alpha     { alpha = new_Alpha; }

-(void)		setDoubleSided	:(BOOL)new_DoubleSided	{ doublesided = new_DoubleSided; }

-(void)     setIBOBuffer    :(GLuint*)new_iboBuffer { iboBuffer = new_iboBuffer; }
-(void)     setIBOSize      :(GLuint)new_iboSize    { iboSize = new_iboSize; }

@end
