#import <glm/gtc/type_ptr.hpp>

#import "Vector3f.h"

@interface Quaternion : NSObject {
    
    float   x, y, z, w;
}

-(id)           init               :(float)in_X  :(float)in_Y  :(float)in_Z  W:(float)in_W;   // (Naming W scalar argument stipulates its placement)
-(id)           initFromAngleAxis  :(float)angleDegrees  :(Vector3f*)axes;

-(float)        getX;
-(float)        getY;
-(float)        getZ;
-(float)        getW;
-(float*)       getXptr;
-(NSString*)    toString;

+(Quaternion*)  normalize         :(Quaternion*)in_Quaternion;
+(Quaternion*)  multiply          :(Quaternion*)left   :(Quaternion*)right;
+(Quaternion*)  interpolate       :(Quaternion*)fromQ  :(Quaternion*)toQ  :(float)progression;
+(glm::quat)    toGLMquat         :(Quaternion*)q;

@end
