# MeshP2

MeshP2.framework for macOS parses and animates P-Squared (.p2) format mesh files.

P2 meshes are derived from, and an incompatible superset of, Autodesk's ancient .3ds format.

P2 meshes begin life as Blender models exported to .p2 format using my Blender add-on: [io\_scene\_p2](https://p-squared.com/sources/io_scene_p2.zip).

When called by a consuming application such as DisplayP2, this MeshP2.framework parses and converts the P2 mesh to OpenGL.

### Current limitations:

* P2 meshes exported by io\_scene\_p2 are limited to 65,535 vertices and 512 skeletal bones,
* P2 meshes imported by this MeshP2.framework are further limited to about 66 skeletal bones.

### Prerequisites for Developers:

To compile and build MeshP2 requires two math library headers, [GLM](https://github.com/g-truc/glm) and [Eigen](https://eigen.tuxfamily.org/index.php?title=Main_Page), be installed prior to building.

MeshP2 source code is [Free Software](https://www.gnu.org/philosophy/free-sw.en.html) and further placed in the public domain under a [CC0 no copyright declaration](https://creativecommons.org/publicdomain/zero/1.0/).

If you found MeshP2 useful, please consider making a charitable donation to the [Free Software Foundation](https://fsf.org).
