#import "Constants.h"

@interface VERTEX : NSObject {
	
    GLfloat	    x, y, z;				    // Position Vector
    GLfloat	    nx, ny, nz;				    // Normal Vector
    GLfloat     tx, ty, tz;                 // Tangent Vector
    GLfloat	    u, v;					    // Texture Coords
    
    NSMutableArray  *flags;                 // Imported Vertex Flags
    NSArray         *boneIndicesAndWeights; // Vertex Flags arrayed as Bone Indices and Weights
}

-(id) init  :(GLfloat)new_X		:(GLfloat)new_Y		:(GLfloat)new_Z
            :(GLfloat)new_NX	:(GLfloat)new_NY	:(GLfloat)new_NZ
            :(GLfloat)new_TX	:(GLfloat)new_TY	:(GLfloat)new_TZ
            :(GLfloat)new_U     :(GLfloat)new_V
            :(NSMutableArray*)new_Flags;

-(GLfloat)  getX;
-(GLfloat)  getY;
-(GLfloat)  getZ;

-(GLfloat)  getNX;
-(GLfloat)  getNY;
-(GLfloat)  getNZ;

-(GLfloat)  getTX;
-(GLfloat)  getTY;
-(GLfloat)  getTZ;

-(GLfloat)  getU;
-(GLfloat)  getV;

-(NSMutableArray*) getFlags;
-(NSArray*)        getBoneIndicesAndWeights;

-(void)     BuildBoneIndicesAndWeightsArray;

-(void)	    setX	 :(GLfloat)new_X;
-(void)	    setY	 :(GLfloat)new_Y;
-(void)	    setZ	 :(GLfloat)new_Z;

-(void)	    setNX	 :(GLfloat)new_NX;
-(void)	    setNY	 :(GLfloat)new_NY;
-(void)	    setNZ	 :(GLfloat)new_NZ;

-(void)	    setTX	 :(GLfloat)new_TX;
-(void)	    setTY	 :(GLfloat)new_TY;
-(void)	    setTZ	 :(GLfloat)new_TZ;

-(void)     setU     :(GLfloat)new_U;
-(void)     setV     :(GLfloat)new_V;

-(void)     addFlag  :(GLushort)new_Flag;

-(void)	    Zoom	 :(float)zoom;

@end
