#import <glm/gtc/type_ptr.hpp>

@interface Vector3f : NSObject {
    
    float  x, y, z;
}

-(id)        init    :(float)in_X     :(float)in_Y    :(float)in_Z;
-(id)        initFromGLM  :(glm::vec3)in_glmVec3;

-(float)     getX;
-(float)     getY;
-(float)     getZ;

-(float*)    getXptr;
-(float*)    getYptr;
-(float*)    getZptr;

-(void)      setX   :(float)in_X;
-(void)      setY   :(float)in_Y;
-(void)      setZ   :(float)in_Z;

-(id)        normalize;

+(Vector3f*) interpolateVector  :(Vector3f*)start  :(Vector3f*)end    :(float)progression;
+(Vector3f*) scale              :(Vector3f*)vec    :(float)scale;
+(Vector3f*) add                :(Vector3f*)left   :(Vector3f*)right;
+(Vector3f*) sub                :(Vector3f*)left   :(Vector3f*)right;
+(Vector3f*) multiply           :(Vector3f*)left   :(Vector3f*)right;
+(Vector3f*) cross              :(Vector3f*)v1     :(Vector3f*)v2;
+(float)     dot                :(Vector3f*)left   :(Vector3f*)right;

@end
