#import "Vector4f.h"

@implementation Vector4f

-(id)   init   :(float)in_X  :(float)in_Y  :(float)in_Z  W:(float)in_W {
    
    if ((self = [super init])) {
        
        x   = in_X;
        y   = in_Y;
        z   = in_Z;
        w   = in_W;
    }
    
    return self;
}
-(id)   initFromGLM  :(glm::vec4)in_glmVec4 {
    
    if ((self = [super init])) {
        
        x   = in_glmVec4.x;
        y   = in_glmVec4.y;
        z   = in_glmVec4.z;
        w   = in_glmVec4.w;
    }
    
    return self;
}

-(float)    getX    { return x; }
-(float)    getY    { return y; }
-(float)    getZ    { return z; }
-(float)    getW    { return w; }

-(float*)   getXptr { return &x; }
-(float*)   getYptr { return &y; }
-(float*)   getZptr { return &z; }
-(float*)   getWptr { return &w; }

-(void)     setX    :(float)in_X    { x = in_X; };
-(void)     setY    :(float)in_Y    { y = in_Y; };
-(void)     setZ    :(float)in_Z    { z = in_Z; };
-(void)     setW    :(float)in_W    { w = in_W; };

+(Vector4f*) transform  :(Matrix4f*)matrix  :(Vector4f*)src {
    
    Vector4f *dest = [Vector4f new];

    float x = (matrix->m00 * [src getX]) + (matrix->m10 * [src getY]) + (matrix->m20 * [src getZ]) + (matrix->m30 * [src getW]);
    float y = (matrix->m01 * [src getX]) + (matrix->m11 * [src getY]) + (matrix->m21 * [src getZ]) + (matrix->m31 * [src getW]);
    float z = (matrix->m02 * [src getX]) + (matrix->m12 * [src getY]) + (matrix->m22 * [src getZ]) + (matrix->m32 * [src getW]);
    float w = (matrix->m03 * [src getX]) + (matrix->m13 * [src getY]) + (matrix->m23 * [src getZ]) + (matrix->m33 * [src getW]);
    
    [dest setX  :x];
    [dest setY  :y];
    [dest setZ  :z];
    [dest setW  :w];
    
    return dest;
}

+(float)     dot  :(Vector4f*)left  :(Vector4f*)right {
    
    return left.getX * right.getX + left.getY * right.getY + left.getZ * right.getZ + left.getW * right.getW;
}

@end
